diff -ruN vdr-1.7.0/CONTRIBUTORS vdr-1.7.1/CONTRIBUTORS
--- vdr-1.7.0/CONTRIBUTORS	2008-04-13 15:30:55.000000000 +0200
+++ vdr-1.7.1/CONTRIBUTORS	2008-09-06 16:49:19.000000000 +0200
@@ -1054,6 +1054,7 @@
  for fixing displaying the free disk space when entering the recordings menu where
  the last replayed recording was in a subdirectory, and pressing Back
  for setting the thread name, so that it can be seen in 'top -H'
+ for replacing the Finnish language code "smi" with "suo"
 
 Ralf Klueber <ralf.klueber@vodafone.com>
  for reporting a bug in cutting a recording if there is only a single editing mark
@@ -1180,6 +1181,8 @@
  early stage of channel switching
  for fixing displaying transponder data when it is modified
  for fixing handling the counter in detection of pre 1.3.19 PS data
+ for adapting the tuning code to the new DVBFE_SET_DELSYS API
+ for reporting the missing description of the 'S' channel parameter in vdr.5
 
 Richard Robson <richard_robson@beeb.net>
  for reporting freezing replay if a timer starts while in Transfer Mode from the
@@ -1328,6 +1331,8 @@
 
 Michael Pennewiß <M.Pennewiss@ARD-Digital.de>
  for pointing out that an empty EPG event means there is currently no running event
+ for advance information about the use of the standard component descriptor for AC3
+ (stream=4) on the German ARD channels
 
 Marcus Mönnig <minibbjd@gmx.de>
  for adding some 3-letter language codes
@@ -1581,6 +1586,7 @@
  for making housekeeping wait for a while after a replay has ended
  for fixing error handling in cCuttingThread::Action()
  for suppressing the automatic shutdown if the remote control is currently disabled
+ for fixing a problem with calling isyslog() from within the SignalHandler()
 
 Sven Kreiensen <svenk@kammer.uni-hannover.de>
  for his help in keeping 'channels.conf.terr' up to date
@@ -1898,6 +1904,7 @@
  for fixing cTimer::operator=() in case a cTimer variable is assigned to itself
  for making the list of tracks given in cStatus::SetAudioTrack() NULL terminated
  for fixing handling kLeft in the calls to cStatus::MsgOsdTextItem()
+ for fixing a possible integer overflow in GetAbsTime()
 
 Philip Prindeville <philipp_subx@redfish-solutions.com>
  for updates to 'sources.conf'
@@ -2119,6 +2126,7 @@
  for making the non-breaking space symbol be rendered as a blank
  for fixing a signed character used as index in cBase64Encoder::NextLine()
  for fixing formatting the name section in the VDR man pages
+ for reporting unneeded include files <linux/dvb/dmx.h> und <time.h> in remux.h
 
 Helge Lenz <h.lenz@gmx.de>
  for reporting a bug in setting the 'Delta' parameter when calling the shutdown
@@ -2355,3 +2363,15 @@
 
 Nan Feng <nfgx@21cn.com>
  for translating OSD texts to the Chinese language
+
+Edgar Toernig <froese@gmx.de>
+ for suggesting to not call FcFini() to avoid problems with older (broken) versions
+ of fontconfig
+
+Michael Nork <mnork0@gmx.net>
+ for suggesting to remove the compile time option VFAT to allow users of precompiled
+ binary distributions to have full control over whether or not to use the --vfat
+ option at runtime
+
+Winfried Köhler <w_koehl@gmx.de>
+ for fixing wrong value for TableIdBAT in libsi/si.h
diff -ruN vdr-1.7.0/HISTORY vdr-1.7.1/HISTORY
--- vdr-1.7.0/HISTORY	2008-04-13 15:35:09.000000000 +0200
+++ vdr-1.7.1/HISTORY	2008-09-06 16:48:51.000000000 +0200
@@ -5761,3 +5761,73 @@
   Andreas Mair).
 - Increased the time between checking the CAM status to 500ms to avoid problems
   with some CAMs (reported by Arthur Konovalov).
+
+2008-09-06: Version 1.7.1
+
+- Adapted the tuning code to the new DVBFE_SET_DELSYS API (thanks to Reinhard Nissl).
+  VDR now uses the driver from http://jusst.de/hg/multiproto_plus.
+- Updated the Italian OSD texts (thanks to Diego Pierotto).
+- Removed obsolete $(NCURSESLIB) from the Makefile.
+- Implemented handling the standard component descriptor for AC3 (stream=4), as it
+  will soon be used by the German ARD channels (thanks to Michael Pennewiß for
+  advance information about this change). The previously used "Premiere pseudo
+  standard" (stream=2, type=5) still works, but has apparently been wrongfully used
+  by broadcasters from the beginning.
+- Added missing description of the 'S' channel parameter to vdr.5 (reported by
+  Reinhard Nissl).
+- The SVDRP signon message now indicates the character encoding in use, as in
+  "220 video SVDRP VideoDiskRecorder 1.7.1; Fri May  2 16:17:10 2008; ISO-8859-1".
+  This may be useful for instance for external tools that provide EPG data, so that
+  they can correctly encode the strings.
+- No longer calling FcFini() to avoid problems with older (broken) versions of
+  fontconfig (suggested by Edgar Toernig).
+- Removed the compile time option VFAT to allow users of precompiled binary
+  distributions to have full control over whether or not to use the --vfat option
+  at runtime (suggested by Michael Nork).
+- First step towards switching to TS (Transport Stream) as recording format:
+  + The new function cDevice::PlayTs() is used to play TS packets.
+  + The new functions cDevice::PlayTsVideo() and cDevice::PlayTsAudio()
+    are used to play video and audio TS packets, respectively.
+  + The new function cAudio::PlayTs() is used to play audio TS packets.
+  + The new class cPatPmtGenerator is used to generate a PAT/PMT pair that precedes
+    the TS data in Transfer Mode.
+  + The new class cPatPmtParser is used by cDevice to parse the PAT/PMT data in a
+    TS in order to find out which streams it contains.
+  + The new class cTsToPes is used to convert TS packets to a PES packet.
+  + cTransfer no longer uses cRemux, and doesn't run a separate thread any more.
+    It just generates a PAT/PMT and sends all received TS packets to the primary
+    device's PlayTs().
+  + Live subtitle display no longer uses a ring buffer and separate thread.
+  + cPesAssembler has been removed. Old VDR recordings only contain complete PES
+    packets.
+  + Since a TS needs to have a PAT/PMT, which requires the video stream type to
+    be explicitly given, the format of the VPID field in the channels.conf file
+    and the SVDRP commands NEWC/MODC/LSTC has been extended. The video stream type
+    now follows the VPID and optional PPID, separated by an '=' sign.
+- Updated the sources.conf file (thanks to Oleg Roitburd).
+- Fixed a possible integer overflow in GetAbsTime() (thanks to Alexander Rieger).
+- Fixed a problem with calling isyslog() from within the SignalHandler() (thanks
+  to Udo Richter).
+- Replaced the Finnish language code "smi" with "suo" (thanks to Rolf Ahrenberg).
+- Fixed wrong value for TableIdBAT in libsi/si.h (thanks to Winfried Köhler).
+- Errors in config files no longer keep VDR from starting.
+- Removed unneeded include files <linux/dvb/dmx.h> und <time.h> from remux.h
+  (reported by Tobias Grimm).
+
+2008-09-06: Version 1.6.0-2
+
+- Updated the Italian OSD texts (thanks to Diego Pierotto).
+- The SVDRP signon message now indicates the character encoding in use, as in
+  "220 video SVDRP VideoDiskRecorder 1.7.1; Fri May  2 16:17:10 2008; ISO-8859-1".
+  This may be useful for instance for external tools that provide EPG data, so that
+  they can correctly encode the strings.
+- No longer calling FcFini() to avoid problems with older (broken) versions of
+  fontconfig (suggested by Edgar Toernig).
+- Updated the sources.conf file (thanks to Oleg Roitburd).
+- Fixed a possible integer overflow in GetAbsTime() (thanks to Alexander Rieger).
+- Fixed a problem with calling isyslog() from within the SignalHandler() (thanks
+  to Udo Richter).
+- Replaced the Finnish language code "smi" with "suo" (thanks to Rolf Ahrenberg).
+- Fixed wrong value for TableIdBAT in libsi/si.h (thanks to Winfried Köhler).
+- Removed unneeded include files <linux/dvb/dmx.h> und <time.h> from remux.h
+  (reported by Tobias Grimm).
diff -ruN vdr-1.7.0/INSTALL vdr-1.7.1/INSTALL
--- vdr-1.7.0/INSTALL	2008-03-22 12:09:04.000000000 +0100
+++ vdr-1.7.1/INSTALL	2008-05-03 12:13:25.000000000 +0200
@@ -1,7 +1,7 @@
 Installation of the Video Disk Recorder
 ---------------------------------------
 
-Version 1.6
+Version 1.7
 -----------
 
 Compiling and running the program:
@@ -57,13 +57,8 @@
 the defaults of which can be set via the RCU_DEVICE and LIRC_DEVICE macros,
 respectively.
 
-If your video directory will be on a VFAT partition, add the compile
-time switch
-
-  VFAT=1
-
-to the 'make' command. Alternatively, you can call VDR with the command
-line option '--vfat'.
+If your video directory will be on a VFAT partition, you can call VDR with
+the command line option '--vfat'.
 
 When running, the 'vdr' program writes status information into the
 system log file, which is usually /var/log/messages (or /var/log/user.log,
diff -ruN vdr-1.7.0/Makefile vdr-1.7.1/Makefile
--- vdr-1.7.0/Makefile	2008-02-29 22:43:03.000000000 +0100
+++ vdr-1.7.1/Makefile	2008-05-03 12:13:43.000000000 +0200
@@ -4,7 +4,7 @@
 # See the main source file 'vdr.c' for copyright information and
 # how to reach the author.
 #
-# $Id: Makefile 2.0 2008/02/29 21:43:03 kls Exp $
+# $Id: Makefile 2.2 2008/05/03 10:13:43 kls Exp $
 
 .DELETE_ON_ERROR:
 
@@ -70,11 +70,6 @@
 VDRVERSION = $(shell sed -ne '/define VDRVERSION/s/^.*"\(.*\)".*$$/\1/p' config.h)
 APIVERSION = $(shell sed -ne '/define APIVERSION/s/^.*"\(.*\)".*$$/\1/p' config.h)
 
-ifdef VFAT
-# for people who want their video directory on a VFAT partition
-DEFINES += -DVFAT
-endif
-
 all: vdr i18n
 
 # Implicit rules:
@@ -94,7 +89,7 @@
 # The main program:
 
 vdr: $(OBJS) $(SILIB)
-	$(CXX) $(CXXFLAGS) -rdynamic $(OBJS) $(NCURSESLIB) $(LIBS) $(LIBDIRS) $(SILIB) -o vdr
+	$(CXX) $(CXXFLAGS) -rdynamic $(OBJS) $(LIBS) $(LIBDIRS) $(SILIB) -o vdr
 
 # The libsi library:
 
diff -ruN vdr-1.7.0/PLUGINS/src/hello/HISTORY vdr-1.7.1/PLUGINS/src/hello/HISTORY
--- vdr-1.7.0/PLUGINS/src/hello/HISTORY	2008-03-18 18:18:35.000000000 +0100
+++ vdr-1.7.1/PLUGINS/src/hello/HISTORY	2008-09-06 17:09:04.000000000 +0200
@@ -62,3 +62,7 @@
 2008-03-18: Version 0.2.2
 
 - Updated the Croatian language texts (thanks to Adrian Caval).
+
+2008-009-06 Version 0.2.3
+
+- Updated the Turkish language texts (thanks to Oktay Yolgeçen).
diff -ruN vdr-1.7.0/PLUGINS/src/hello/hello.c vdr-1.7.1/PLUGINS/src/hello/hello.c
--- vdr-1.7.0/PLUGINS/src/hello/hello.c	2008-03-18 18:13:25.000000000 +0100
+++ vdr-1.7.1/PLUGINS/src/hello/hello.c	2008-09-06 17:07:12.000000000 +0200
@@ -3,7 +3,7 @@
  *
  * See the README file for copyright information and how to reach the author.
  *
- * $Id: hello.c 2.0 2008/03/18 17:13:25 kls Exp $
+ * $Id: hello.c 2.1 2008/09/06 15:07:12 kls Exp $
  */
 
 #include <getopt.h>
@@ -12,7 +12,7 @@
 #include <vdr/interface.h>
 #include <vdr/plugin.h>
 
-static const char *VERSION        = "0.2.2";
+static const char *VERSION        = "0.2.3";
 static const char *DESCRIPTION    = trNOOP("A friendly greeting");
 static const char *MAINMENUENTRY  = trNOOP("Hello");
 
diff -ruN vdr-1.7.0/audio.c vdr-1.7.1/audio.c
--- vdr-1.7.0/audio.c	2006-05-28 17:03:24.000000000 +0200
+++ vdr-1.7.1/audio.c	2008-07-06 13:42:58.000000000 +0200
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: audio.c 2.0 2006/05/28 15:03:24 kls Exp $
+ * $Id: audio.c 2.1 2008/07/06 11:42:58 kls Exp $
  */
 
 #include "audio.h"
@@ -32,6 +32,12 @@
       audio->Play(Data, Length, Id);
 }
 
+void cAudios::PlayTsAudio(const uchar *Data, int Length)
+{
+  for (cAudio *audio = First(); audio; audio = Next(audio))
+      audio->PlayTs(Data, Length);
+}
+
 void cAudios::MuteAudio(bool On)
 {
   for (cAudio *audio = First(); audio; audio = Next(audio))
@@ -80,6 +86,29 @@
         }
      else {
         esyslog("ERROR: can't open pipe to audio command '%s'", command);
+        free(command);
+        command = NULL;
+        }
+     }
+}
+
+void cExternalAudio::PlayTs(const uchar *Data, int Length)
+{
+  if (command && !mute) {
+     if (pipe || pipe.Open(command, "w")) {
+        int written = 0;
+        while (Length > 0) {
+              int w = fwrite(Data + written, 1, Length, pipe);
+              if (w < 0) {
+                 LOG_ERROR;
+                 break;
+                 }
+              Length -= w;
+              written += w;
+              }
+        }
+     else {
+        esyslog("ERROR: can't open pipe to audio command '%s'", command);
         free(command);
         command = NULL;
         }
diff -ruN vdr-1.7.0/audio.h vdr-1.7.1/audio.h
--- vdr-1.7.0/audio.h	2005-02-12 13:20:19.000000000 +0100
+++ vdr-1.7.1/audio.h	2008-07-06 13:39:21.000000000 +0200
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: audio.h 2.0 2005/02/12 12:20:19 kls Exp $
+ * $Id: audio.h 2.1 2008/07/06 11:39:21 kls Exp $
  */
 
 #ifndef __AUDIO_H
@@ -24,6 +24,11 @@
        ///< be copied and processed in a separate thread. The Data is always a
        ///< complete PES audio packet. Id indicates the type of audio data this
        ///< packet holds.
+  virtual void PlayTs(const uchar *Data, int Length) = 0;
+       ///< Plays the given block of audio Data. Must return as soon as possible.
+       ///< If the entire block of data can't be processed immediately, it must
+       ///< be copied and processed in a separate thread. The Data is always a
+       ///< complete TS audio packet.
   virtual void Mute(bool On) = 0;
        ///< Immediately sets the audio device to be silent (On==true) or to
        ///< normal replay (On==false).
@@ -34,6 +39,7 @@
 class cAudios : public cList<cAudio> {
 public:
   void PlayAudio(const uchar *Data, int Length, uchar Id);
+  void PlayTsAudio(const uchar *Data, int Length);
   void MuteAudio(bool On);
   void ClearAudio(void);
   };
@@ -49,6 +55,7 @@
   cExternalAudio(const char *Command);
   virtual ~cExternalAudio();
   virtual void Play(const uchar *Data, int Length, uchar Id);
+  virtual void PlayTs(const uchar *Data, int Length);
   virtual void Mute(bool On);
   virtual void Clear(void);
   };
diff -ruN vdr-1.7.0/channels.c vdr-1.7.1/channels.c
--- vdr-1.7.0/channels.c	2008-04-12 15:49:12.000000000 +0200
+++ vdr-1.7.1/channels.c	2008-07-06 14:59:41.000000000 +0200
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: channels.c 2.2 2008/04/12 13:49:12 kls Exp $
+ * $Id: channels.c 2.3 2008/07/06 12:59:41 kls Exp $
  */
 
 #include "channels.h"
@@ -505,10 +505,10 @@
   return q - s;
 }
 
-void cChannel::SetPids(int Vpid, int Ppid, int *Apids, char ALangs[][MAXLANGCODE2], int *Dpids, char DLangs[][MAXLANGCODE2], int *Spids, char SLangs[][MAXLANGCODE2], int Tpid)
+void cChannel::SetPids(int Vpid, int Ppid, int Vtype, int *Apids, char ALangs[][MAXLANGCODE2], int *Dpids, char DLangs[][MAXLANGCODE2], int *Spids, char SLangs[][MAXLANGCODE2], int Tpid)
 {
   int mod = CHANNELMOD_NONE;
-  if (vpid != Vpid || ppid != Ppid || tpid != Tpid)
+  if (vpid != Vpid || ppid != Ppid || vtype != Vtype || tpid != Tpid)
      mod |= CHANNELMOD_PIDS;
   int m = IntArraysDiffer(apids, Apids, alangs, ALangs) | IntArraysDiffer(dpids, Dpids, dlangs, DLangs) | IntArraysDiffer(spids, Spids, slangs, SLangs);
   if (m & STRDIFF)
@@ -542,9 +542,10 @@
      q = NewSpidsBuf;
      q += IntArrayToString(q, Spids, 10, SLangs);
      *q = 0;
-     dsyslog("changing pids of channel %d from %d+%d:%s:%s:%d to %d+%d:%s:%s:%d", Number(), vpid, ppid, OldApidsBuf, OldSpidsBuf, tpid, Vpid, Ppid, NewApidsBuf, NewSpidsBuf, Tpid);
+     dsyslog("changing pids of channel %d from %d+%d=%d:%s:%s:%d to %d+%d=%d:%s:%s:%d", Number(), vpid, ppid, vtype, OldApidsBuf, OldSpidsBuf, tpid, Vpid, Ppid, Vtype, NewApidsBuf, NewSpidsBuf, Tpid);
      vpid = Vpid;
      ppid = Ppid;
+     vtype = Vtype;
      for (int i = 0; i < MAXAPIDS; i++) {
          apids[i] = Apids[i];
          strn0cpy(alangs[i], ALangs[i], MAXLANGCODE2);
@@ -752,6 +753,8 @@
      q += snprintf(q, sizeof(vpidbuf), "%d", Channel->vpid);
      if (Channel->ppid && Channel->ppid != Channel->vpid)
         q += snprintf(q, sizeof(vpidbuf) - (q - vpidbuf), "+%d", Channel->ppid);
+     if (Channel->vtype)
+        q += snprintf(q, sizeof(vpidbuf) - (q - vpidbuf), "=%d", Channel->vtype);
      *q = 0;
      const int BufferSize = (MAXAPIDS + MAXDPIDS) * (5 + 1 + MAXLANGCODE2) + 10; // 5 digits plus delimiting ',' or ';' plus optional '=cod+cod', +10: paranoia
      char apidbuf[BufferSize];
@@ -813,22 +816,27 @@
            tpid = 0;
            }
         vpid = ppid = 0;
+        vtype = 2; // default is MPEG-2
         apids[0] = 0;
         dpids[0] = 0;
         ok = false;
         if (parambuf && sourcebuf && vpidbuf && apidbuf) {
            ok = StringToParameters(parambuf) && (source = cSource::FromString(sourcebuf)) >= 0;
 
-           char *p = strchr(vpidbuf, '+');
-           if (p)
+           char *p;
+           if ((p = strchr(vpidbuf, '=')) != NULL) {
+              *p++ = 0;
+              if (sscanf(p, "%d", &vtype) != 1)
+                 return false;
+              }
+           if ((p = strchr(vpidbuf, '+')) != NULL) {
               *p++ = 0;
-           if (sscanf(vpidbuf, "%d", &vpid) != 1)
-              return false;
-           if (p) {
               if (sscanf(p, "%d", &ppid) != 1)
                  return false;
               }
-           else
+           if (sscanf(vpidbuf, "%d", &vpid) != 1)
+              return false;
+           if (!ppid)
               ppid = vpid;
 
            char *dpidbuf = strchr(apidbuf, ';');
diff -ruN vdr-1.7.0/channels.h vdr-1.7.1/channels.h
--- vdr-1.7.0/channels.h	2008-04-12 15:46:50.000000000 +0200
+++ vdr-1.7.1/channels.h	2008-07-06 13:49:37.000000000 +0200
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: channels.h 2.2 2008/04/12 13:46:50 kls Exp $
+ * $Id: channels.h 2.3 2008/07/06 11:49:37 kls Exp $
  */
 
 #ifndef __CHANNELS_H
@@ -124,6 +124,7 @@
   int srate;
   int vpid;
   int ppid;
+  int vtype;
   int apids[MAXAPIDS + 1]; // list is zero-terminated
   char alangs[MAXAPIDS][MAXLANGCODE2];
   int dpids[MAXDPIDS + 1]; // list is zero-terminated
@@ -178,6 +179,7 @@
   int Srate(void) const { return srate; }
   int Vpid(void) const { return vpid; }
   int Ppid(void) const { return ppid; }
+  int Vtype(void) const { return vtype; }
   const int *Apids(void) const { return apids; }
   const int *Dpids(void) const { return dpids; }
   const int *Spids(void) const { return spids; }
@@ -225,7 +227,7 @@
   void SetId(int Nid, int Tid, int Sid, int Rid = 0);
   void SetName(const char *Name, const char *ShortName, const char *Provider);
   void SetPortalName(const char *PortalName);
-  void SetPids(int Vpid, int Ppid, int *Apids, char ALangs[][MAXLANGCODE2], int *Dpids, char DLangs[][MAXLANGCODE2], int *Spids, char SLangs[][MAXLANGCODE2], int Tpid);
+  void SetPids(int Vpid, int Ppid, int Vtype, int *Apids, char ALangs[][MAXLANGCODE2], int *Dpids, char DLangs[][MAXLANGCODE2], int *Spids, char SLangs[][MAXLANGCODE2], int Tpid);
   void SetCaIds(const int *CaIds); // list must be zero-terminated
   void SetCaDescriptors(int Level);
   void SetLinkChannels(cLinkChannels *LinkChannels);
diff -ruN vdr-1.7.0/config.h vdr-1.7.1/config.h
--- vdr-1.7.0/config.h	2008-04-12 15:02:10.000000000 +0200
+++ vdr-1.7.1/config.h	2008-09-06 16:06:56.000000000 +0200
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: config.h 2.1 2008/04/12 13:02:10 kls Exp $
+ * $Id: config.h 2.3 2008/09/06 14:06:56 kls Exp $
  */
 
 #ifndef __CONFIG_H
@@ -22,8 +22,8 @@
 
 // VDR's own version number:
 
-#define VDRVERSION  "1.7.0"
-#define VDRVERSNUM   10700  // Version * 10000 + Major * 100 + Minor
+#define VDRVERSION  "1.7.1"
+#define VDRVERSNUM   10701  // Version * 10000 + Major * 100 + Minor
 
 // The plugin API's version number:
 
@@ -122,7 +122,6 @@
                       esyslog("ERROR: error in %s, line %d", fileName, line);
                       delete l;
                       result = false;
-                      break;
                       }
                    }
                 }
diff -ruN vdr-1.7.0/device.c vdr-1.7.1/device.c
--- vdr-1.7.0/device.c	2008-04-12 16:12:14.000000000 +0200
+++ vdr-1.7.1/device.c	2008-07-06 15:22:21.000000000 +0200
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: device.c 2.2 2008/04/12 14:12:14 kls Exp $
+ * $Id: device.c 2.3 2008/07/06 13:22:21 kls Exp $
  */
 
 #include "device.h"
@@ -21,16 +21,9 @@
 
 // --- cLiveSubtitle ---------------------------------------------------------
 
-#define LIVESUBTITLEBUFSIZE  KILOBYTE(100)
-
-class cLiveSubtitle : public cReceiver, public cThread {
-private:
-  cRingBufferLinear *ringBuffer;
-  cRemux *remux;
+class cLiveSubtitle : public cReceiver {
 protected:
-  virtual void Activate(bool On);
   virtual void Receive(uchar *Data, int Length);
-  virtual void Action(void);
 public:
   cLiveSubtitle(int SPid);
   virtual ~cLiveSubtitle();
@@ -38,170 +31,17 @@
 
 cLiveSubtitle::cLiveSubtitle(int SPid)
 :cReceiver(tChannelID(), -1, SPid)
-,cThread("live subtitle")
 {
-  ringBuffer = new cRingBufferLinear(LIVESUBTITLEBUFSIZE, TS_SIZE * 2, true, "Live Subtitle");
-  int NoPids = 0;
-  int SPids[] = { SPid, 0 };
-  remux = new cRemux(0, &NoPids, &NoPids, SPids);
 }
 
 cLiveSubtitle::~cLiveSubtitle()
 {
   cReceiver::Detach();
-  delete remux;
-  delete ringBuffer;
-}
-
-void cLiveSubtitle::Activate(bool On)
-{
-  if (On)
-     Start();
-  else
-     Cancel(3);
 }
 
 void cLiveSubtitle::Receive(uchar *Data, int Length)
 {
-  if (Running()) {
-     int p = ringBuffer->Put(Data, Length);
-     if (p != Length && Running())
-        ringBuffer->ReportOverflow(Length - p);
-     }
-}
-
-void cLiveSubtitle::Action(void)
-{
-  while (Running()) {
-        int Count;
-        uchar *b = ringBuffer->Get(Count);
-        if (b) {
-           Count = remux->Put(b, Count);
-           if (Count)
-              ringBuffer->Del(Count);
-           }
-        b = remux->Get(Count);
-        if (b) {
-           Count = cDevice::PrimaryDevice()->PlaySubtitle(b, Count);
-           remux->Del(Count);
-           }
-        }
-}
-
-// --- cPesAssembler ---------------------------------------------------------
-
-class cPesAssembler {
-private:
-  uchar *data;
-  uint32_t tag;
-  int length;
-  int size;
-  bool Realloc(int Size);
-public:
-  cPesAssembler(void);
-  ~cPesAssembler();
-  int ExpectedLength(void) { return PacketSize(data); }
-  static int PacketSize(const uchar *data);
-  int Length(void) { return length; }
-  const uchar *Data(void) { return data; } // only valid if Length() >= 4
-  void Reset(void);
-  void Put(uchar c);
-  void Put(const uchar *Data, int Length);
-  bool IsPes(void);
-  };
-
-cPesAssembler::cPesAssembler(void)
-{
-  data = NULL;
-  size = 0;
-  Reset();
-}
-
-cPesAssembler::~cPesAssembler()
-{
-  free(data);
-}
-
-void cPesAssembler::Reset(void)
-{
-  tag = 0xFFFFFFFF;
-  length = 0;
-}
-
-bool cPesAssembler::Realloc(int Size)
-{
-  if (Size > size) {
-     size = max(Size, 2048);
-     data = (uchar *)realloc(data, size);
-     if (!data) {
-        esyslog("ERROR: can't allocate memory for PES assembler");
-        length = 0;
-        size = 0;
-        return false;
-        }
-     }
-  return true;
-}
-
-void cPesAssembler::Put(uchar c)
-{
-  if (length < 4) {
-     tag = (tag << 8) | c;
-     if ((tag & 0xFFFFFF00) == 0x00000100) {
-        if (Realloc(4)) {
-           *(uint32_t *)data = htonl(tag);
-           length = 4;
-           }
-        }
-     else if (length < 3)
-        length++;
-     }
-  else if (Realloc(length + 1))
-     data[length++] = c;
-}
-
-void cPesAssembler::Put(const uchar *Data, int Length)
-{
-  while (length < 4 && Length > 0) {
-        Put(*Data++);
-        Length--;
-        }
-  if (Length && Realloc(length + Length)) {
-     memcpy(data + length, Data, Length);
-     length += Length;
-     }
-}
-
-int cPesAssembler::PacketSize(const uchar *data)
-{
-  // we need atleast 6 bytes of data here !!!
-  switch (data[3]) {
-    default:
-    case 0x00 ... 0xB8: // video stream start codes
-    case 0xB9: // Program end
-    case 0xBC: // Programm stream map
-    case 0xF0 ... 0xFF: // reserved
-         return 6;
-
-    case 0xBA: // Pack header
-         if ((data[4] & 0xC0) == 0x40) // MPEG2
-            return 14;
-         // to be absolutely correct we would have to add the stuffing bytes
-         // as well, but at this point we only may have 6 bytes of data avail-
-         // able. So it's up to the higher level to resync...
-         //return 14 + (data[13] & 0x07); // add stuffing bytes
-         else // MPEG1
-            return 12;
-
-    case 0xBB: // System header
-    case 0xBD: // Private stream1
-    case 0xBE: // Padding stream
-    case 0xBF: // Private stream2 (navigation data)
-    case 0xC0 ... 0xCF: // all the rest (the real packets)
-    case 0xD0 ... 0xDF:
-    case 0xE0 ... 0xEF:
-         return 6 + data[4] * 256 + data[5];
-    }
+  cDevice::PrimaryDevice()->PlayTs(Data, Length);
 }
 
 // --- cDevice ---------------------------------------------------------------
@@ -241,7 +81,6 @@
   startScrambleDetection = 0;
 
   player = NULL;
-  pesAssembler = new cPesAssembler;
   ClrAvailableTracks();
   currentAudioTrack = ttNone;
   currentAudioTrackMissingCount = 0;
@@ -265,7 +104,6 @@
   DetachAllReceivers();
   delete liveSubtitle;
   delete dvbSubtitleConverter;
-  delete pesAssembler;
 }
 
 bool cDevice::WaitForAllDevicesReady(int Timeout)
@@ -1195,7 +1033,6 @@
         Detach(player);
      DELETENULL(liveSubtitle);
      DELETENULL(dvbSubtitleConverter);
-     pesAssembler->Reset();
      player = Player;
      if (!Transferring())
         ClrAvailableTracks(false, true);
@@ -1256,7 +1093,7 @@
 {
   if (!dvbSubtitleConverter)
      dvbSubtitleConverter = new cDvbSubtitleConverter;
-  return dvbSubtitleConverter->Convert(Data, Length);
+  return dvbSubtitleConverter->ConvertFragments(Data, Length);
 }
 
 int cDevice::PlayPesPacket(const uchar *Data, int Length, bool VideoOnly)
@@ -1360,42 +1197,16 @@
 int cDevice::PlayPes(const uchar *Data, int Length, bool VideoOnly)
 {
   if (!Data) {
-     pesAssembler->Reset();
      if (dvbSubtitleConverter)
         dvbSubtitleConverter->Reset();
      return 0;
      }
-  int Result = 0;
-  if (pesAssembler->Length()) {
-     // Make sure we have a complete PES header:
-     while (pesAssembler->Length() < 6 && Length > 0) {
-           pesAssembler->Put(*Data++);
-           Length--;
-           Result++;
-           }
-     if (pesAssembler->Length() < 6)
-        return Result; // Still no complete PES header - wait for more
-     int l = pesAssembler->ExpectedLength();
-     int Rest = min(l - pesAssembler->Length(), Length);
-     pesAssembler->Put(Data, Rest);
-     Data += Rest;
-     Length -= Rest;
-     Result += Rest;
-     if (pesAssembler->Length() < l)
-        return Result; // Still no complete PES packet - wait for more
-     // Now pesAssembler contains one complete PES packet.
-     int w = PlayPesPacket(pesAssembler->Data(), pesAssembler->Length(), VideoOnly);
-     if (w > 0)
-        pesAssembler->Reset();
-     return Result > 0 ? Result : w < 0 ? w : 0;
-     }
   int i = 0;
   while (i <= Length - 6) {
         if (Data[i] == 0x00 && Data[i + 1] == 0x00 && Data[i + 2] == 0x01) {
-           int l = cPesAssembler::PacketSize(&Data[i]);
+           int l = PesLength(Data + i);
            if (i + l > Length) {
-              // Store incomplete PES packet for later completion:
-              pesAssembler->Put(Data + i, Length - i);
+              esyslog("ERROR: incomplete PES packet!");
               return Length;
               }
            int w = PlayPesPacket(Data + i, l, VideoOnly);
@@ -1408,10 +1219,91 @@
            i++;
         }
   if (i < Length)
-     pesAssembler->Put(Data + i, Length - i);
+     esyslog("ERROR: leftover PES data!");
   return Length;
 }
 
+int cDevice::PlayTsVideo(const uchar *Data, int Length)
+{
+  // Video PES has no explicit length, so we can only determine the end of
+  // a PES packet when the next TS packet that starts a payload comes in:
+  if (TsPayloadStart(Data)) {
+     if (const uchar *p = tsToPesVideo.GetPes(Length)) {
+        int w = PlayVideo(p, Length);
+        if (w > 0)
+           tsToPesVideo.Reset();
+        else
+           return w;
+        }
+     }
+  tsToPesVideo.PutTs(Data, Length);
+  return Length;
+}
+
+int cDevice::PlayTsAudio(const uchar *Data, int Length)
+{
+  bool PayloadStart = TsPayloadStart(Data);
+  for (int Pass = 0; Pass < 2; Pass++) {
+      if (Pass == 0 && !PayloadStart) // if no new payload is started, we can always put the packet into the converter
+         tsToPesAudio.PutTs(Data, Length);
+      if (const uchar *p = tsToPesAudio.GetPes(Length)) {
+         int w = PlayAudio(p, Length, 0);
+         if (w > 0)
+            tsToPesAudio.Reset();
+         else if (PayloadStart)
+            return w; // must get out the old packet before starting a new one
+         }
+      if (Pass == 0 && PayloadStart)
+         tsToPesAudio.PutTs(Data, Length);
+      }
+  return Length;
+}
+
+int cDevice::PlayTsSubtitle(const uchar *Data, int Length)
+{
+  if (!dvbSubtitleConverter)
+     dvbSubtitleConverter = new cDvbSubtitleConverter;
+  tsToPesSubtitle.PutTs(Data, Length);
+  if (const uchar *p = tsToPesSubtitle.GetPes(Length)) {
+     dvbSubtitleConverter->Convert(p, Length);
+     tsToPesSubtitle.Reset();
+     }
+  return Length;
+}
+
+//TODO detect and report continuity errors?
+int cDevice::PlayTs(const uchar *Data, int Length, bool VideoOnly)
+{
+  if (Length == TS_SIZE) {
+     if (!TsHasPayload(Data))
+        return Length; // silently ignore TS packets w/o payload
+     int PayloadOffset = TsPayloadOffset(Data);
+     if (PayloadOffset < Length) {
+        int Pid = TsPid(Data);
+        if (Pid == 0)
+           patPmtParser.ParsePat(Data + PayloadOffset, Length - PayloadOffset);
+        else if (Pid == patPmtParser.PmtPid())
+           patPmtParser.ParsePmt(Data + PayloadOffset, Length - PayloadOffset);
+        else if (Pid == patPmtParser.Vpid())
+           return PlayTsVideo(Data, Length);
+        else if (Pid == availableTracks[currentAudioTrack].id) {
+           if (!VideoOnly || HasIBPTrickSpeed()) {
+              int w = PlayTsAudio(Data, Length);
+              if (w > 0)
+                 Audios.PlayTsAudio(Data, Length);
+              return w;
+              }
+           }
+        else if (Pid == availableTracks[currentSubtitleTrack].id) {
+           if (!VideoOnly || HasIBPTrickSpeed())
+              return PlayTsSubtitle(Data, Length);
+           }
+        return Length;
+        }
+     }
+  return -1;
+}
+
 int cDevice::Priority(void) const
 {
   int priority = IsPrimaryDevice() ? Setup.PrimaryLimit - 1 : DEFAULTPRIORITY;
@@ -1448,7 +1340,7 @@
            uchar *b = NULL;
            if (GetTSPacket(b)) {
               if (b) {
-                 int Pid = (((uint16_t)b[1] & PID_MASK_HI) << 8) | b[2];
+                 int Pid = TsPid(b);
                  // Check whether the TS packets are scrambled:
                  bool DetachReceivers = false;
                  bool DescramblingOk = false;
